using System;
using Antlr.Runtime;
using Antlr.Runtime.Tree;
using Antlr.StringTemplate;
using System.Collections.Generic;

namespace PruAntlr
{
    class Program
    {
        static void Main(string[] args)
        {
            ANTLRFileStream input = new ANTLRFileStream("C:\\pruantlr\\prueba.fks");
            FKVMLexer lexer = new FKVMLexer(input);

            CommonTokenStream tokens = new CommonTokenStream(lexer);
            FKVMParser parser = new FKVMParser(tokens);
            FKVMParser.programa_return result = parser.programa();

            if (parser.numErrors == 0)
            {
                CommonTree t = (CommonTree)result.Tree;

                Console.WriteLine("Arbol AST:");
                Console.WriteLine(t.ToStringTree() + "\n");

                Console.WriteLine("Tabla de Simbolos:");
                foreach (string k in parser.symtable.Keys)
                {
                    Console.WriteLine(((Symbol)parser.symtable[k]).numvar +
                        " - " + k + " -> " + ((Symbol)parser.symtable[k]).type);
                }
            }
            else
            {
                Console.WriteLine("Errores: " + parser.numErrors);
            }

            Console.ReadLine();
        }
    }
}
